﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
 
namespace CreateAndSendPackageREST
{
    public class CreateAndSendPackage
    {
        public static void Main(string[] args)
        {
        
            string apiKey = "YOUR_API_KEY";
            string url = "https://sandbox.e-signlive.com/api";

            string jsonString = "{ \"documents\": [ { \"fields\": [ { \"value\": \"200 E MAIN ST, PHOENIX AZ, 85123 USA\", \"name\": \"Text1\" }, { \"value\": \"Lawn mower\", \"name\": \"Text2\" }, { \"value\": \"Fertilizer\", \"name\": \"Text3\" }, { \"value\": \"100\", \"name\": \"Text4\" }, { \"value\": \"12 12 12\", \"name\": \"Text5\" } ], \"extract\": true, \"name\": \"Sample Contract\" } ], \"type\": \"PACKAGE\", \"status\": \"DRAFT\", \"roles\": [ { \"id\": \"client\", \"index\": 0, \"type\": \"SIGNER\", \"signers\": [ { \"email\": \"john.smith@example.com\", \"firstName\": \"John\", \"lastName\": \"Smith\", \"id\": \"client\" } ], \"name\": \"client\" }, { \"id\": \"contractor\", \"index\": 1, \"type\": \"SENDER\", \"signers\": [ { \"email\": \"myemail@example.com\", \"firstName\": \"Haris\", \"lastName\": \"Haidary\", \"id\": \"contractor\" } ], \"name\": \"contractor\" } ], \"name\": \"Field Injection Example\" }";
             
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");
 
            byte[] fileByteArray = File.ReadAllBytes("PATH_TO_YOUR_PDF.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);
 
            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"NAME_OF_YOUR_FILE.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");
 
            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"NAME_OF_YOUR_FILE.pdf\"");
            form.Add(jsonContent, "\"payload\"");
 
            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");
                         
            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}

